SystemOrganization addCategory: #'Glamour-Tests-Morphic'!

TestCase subclass: #GLMMorphicTest
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

GLMMorphicTest subclass: #GLMAccumulatorMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMAccumulatorMorphicTest methodsFor: 'testing' stamp: 'tg 2/2/2010 22:03'!
testActiveEntity
	| browser tabs |
	browser := GLMAccumulator new.
	browser show: [:a | a list display: [:x | $a to: x ]].
	browser entity: $d.
	browser entity: $e.
	window := browser openOn: $d.
	tabs := window submorphs last.
	tabs selectedPageIndex: 1.
	tabs update: #selectedIndex.
	self assert: browser activeEntity = $d.! !

!GLMAccumulatorMorphicTest methodsFor: 'testing' stamp: 'tg 1/18/2010 08:51'!
testCreation
	| browser |
	browser := GLMAccumulator new.
	browser show: [:a | a list display: [:x | $a to: x ]].
	window := browser openOn: $d.
	self assert: window submorphs last class = LazyTabGroupMorph.! !

!GLMAccumulatorMorphicTest methodsFor: 'testing' stamp: 'tg 1/18/2010 09:07'!
testListInside
	| browser tabs firstTreeMorph |
	browser := GLMAccumulator new.
	browser show: [:a | a list display: [:x | $a to: x ]].
	window := browser openOn: $d.
	tabs := window submorphs last.
	self assert: (tabs pageAt: 1) submorphs first submorphs first class = LazyMorphTreeMorph.
	firstTreeMorph := (tabs pageAt: 1) submorphs first submorphs first.
	self assert: ((firstTreeMorph roots collect: #complexContents) collect: #item) = ($a to: $d) asArray! !

!GLMAccumulatorMorphicTest methodsFor: 'testing' stamp: 'lr 6/4/2010 13:53'!
testPaneCreation
	| browser tabs |
	browser := GLMAccumulator new.
	browser show: [:a | a list display: [:x | $a to: x ]].
	window := browser openOn: $d.
	tabs := window submorphs last.
	self assert: tabs pages size = 1.
	self assert: tabs lazyPages size = 1.
	browser entity: $c.
	self assert: tabs lazyPages size = 2! !

!GLMAccumulatorMorphicTest methodsFor: 'testing' stamp: 'lr 6/4/2010 14:36'!
testSelectedTab
	| browser tabs |
	browser := GLMAccumulator new.
	browser show: [:a | 
		a title: [:x | x asString ].
		a list display: [:x | $a to: x ]].
	window := browser openOn: $d.
	tabs := window submorphs last.
	self assert: tabs selectedPageIndex = 1.
	browser entity: $c.
	self assert: tabs selectedPageIndex = 2.
	browser entity: $d.
	self assert: tabs selectedPageIndex = 1! !

!GLMAccumulatorMorphicTest methodsFor: 'testing' stamp: 'lr 6/4/2010 13:53'!
testTabTitle
	| browser tabs firstTabLabel |
	browser := GLMAccumulator new.
	browser show: [:a | 
		a title: [:x | x asString ].
		a list display: [:x | $a to: x ]].
	window := browser openOn: $d.
	tabs := window submorphs last.
	firstTabLabel := tabs tabSelectorMorph submorphs first submorphs first.
	self assert: firstTabLabel contents = 'd'.! !

GLMMorphicTest subclass: #GLMCompositePresentationMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMCompositePresentationMorphicTest methodsFor: 'testing' stamp: 'tg 1/14/2010 23:00'!
testAccordion
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a accordionArrangement.
		a list title: 'List'.
		a text title: 'Text'].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph class = PanelMorph.
	self assert: compositeMorph submorphs notEmpty.
	self assert: compositeMorph submorphs size = 2.
	self assert: compositeMorph submorphs first class = ExpanderMorph.
	self assert: compositeMorph submorphs last class = ExpanderMorph.! !

!GLMCompositePresentationMorphicTest methodsFor: 'testing' stamp: 'tg 1/14/2010 23:00'!
testAccordionExpanded
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a accordionArrangement.
		a list title: 'List'.
		a text title: 'Text'].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph submorphs first expanded.
	self assert: compositeMorph submorphs last expanded not.! !

!GLMCompositePresentationMorphicTest methodsFor: 'testing' stamp: 'tg 9/13/2010 19:29'!
testAccordionWithTitle
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a accordionArrangement.
		a title: 'title'.
		a list.
		a text ].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph class = LazyTabGroupMorph.
	self assert: compositeMorph submorphs notEmpty.
	self assert: compositeMorph submorphs size = 2.
	self assert: compositeMorph contentMorph class = PanelMorph.
	self assert: compositeMorph contentMorph submorphs first submorphs size = 2.
	self assert: compositeMorph contentMorph submorphs first submorphs first class = ExpanderMorph! !

!GLMCompositePresentationMorphicTest methodsFor: 'testing' stamp: 'tg 9/13/2010 19:30'!
testFinder
	| finder |
	finder := GLMFinder new.
	finder show: [:a |
		a title: 'something'.
		a stackedArrangement.
		a list.
		a text].
	self assert: finder presentations size = 2.
	self assert: (finder presentations arrangement isKindOf: GLMStackedVerticallyArrangement).
	window := finder openOn: (1 to: 42).
	self assert: (window submorphs last submorphs first submorphs first submorphs first isKindOf: LazyTabGroupMorph) ! !

!GLMCompositePresentationMorphicTest methodsFor: 'testing' stamp: 'tg 9/13/2010 19:30'!
testOneStackedVerticallyWithTitle
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a stackedVerticallyArrangement.
		a title: 'title'.
		a list ].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph class = LazyTabGroupMorph.
	self assert: compositeMorph submorphs notEmpty.
	self assert: compositeMorph submorphs size = 2.
	self assert: compositeMorph contentMorph class = PanelMorph.
	self assert: compositeMorph contentMorph submorphs size = 1.
	self assert: compositeMorph contentMorph submorphs first class = PanelMorph.
	self assert: compositeMorph contentMorph submorphs first submorphs size = 1.
	self assert: compositeMorph contentMorph submorphs first submorphs first class = LazyTabGroupMorph! !

!GLMCompositePresentationMorphicTest methodsFor: 'testing' stamp: 'tg 9/13/2010 19:30'!
testStackedVertically
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a stackedVerticallyArrangement.
		a list title: 'list'.
		a text title: 'text'].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph class = PanelMorph.
	self assert: compositeMorph submorphs size = 2.
	self assert: compositeMorph submorphs size = 2.
	self assert: compositeMorph submorphs first class = LazyTabGroupMorph.! !

!GLMCompositePresentationMorphicTest methodsFor: 'testing' stamp: 'tg 9/13/2010 19:30'!
testStackedVerticallyWithTitle
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a stackedVerticallyArrangement.
		a title: 'title'.
		a list title: 'list'.
		a text title: 'text'].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph class = LazyTabGroupMorph.
	self assert: compositeMorph submorphs notEmpty.
	self assert: compositeMorph submorphs size = 2.
	self assert: compositeMorph contentMorph class = PanelMorph.
	self assert: compositeMorph contentMorph submorphs size = 1.
	self assert: compositeMorph contentMorph submorphs first class = PanelMorph.
	self assert: compositeMorph contentMorph submorphs first submorphs size = 2.
	self assert: compositeMorph contentMorph submorphs first submorphs first class = LazyTabGroupMorph! !

!GLMCompositePresentationMorphicTest methodsFor: 'testing' stamp: 'tg 1/14/2010 23:00'!
testTabs
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a list.
		a text ].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph class = LazyTabGroupMorph.
	self assert: compositeMorph lazyPages size = 2.! !

!GLMCompositePresentationMorphicTest methodsFor: 'testing' stamp: 'tg 9/13/2010 19:30'!
testTabsWithTitle
	| browser compositeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | 
		a title: 'title'.
		a list.
		a text ].
	window := browser openOn: 42.
	compositeMorph := window submorphs last submorphs last submorphs last.
	self assert: compositeMorph class = LazyTabGroupMorph.
	self assert: compositeMorph submorphs size = 2.
	self assert: compositeMorph submorphs first class = PanelMorph.
	self assert: compositeMorph submorphs first submorphs size = 1.
	self assert: compositeMorph submorphs first submorphs first class = LazyTabGroupMorph.
	self assert: compositeMorph submorphs first submorphs first lazyPages size = 2.! !

GLMMorphicTest subclass: #GLMExpanderMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMExpanderMorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/3/2011 21:13'!
testCreation
	| browser |
	browser := GLMExpander new.
	browser show: [ :a | a text ].
	window := browser openOn: #(a b c).
	self assert: window submorphs last class = LazyMorphTreeMorph.
	self assert: window submorphs last roots size = 1.
	self assert: window submorphs last roots first children size = 1! !

!GLMMorphicTest methodsFor: 'private' stamp: 'tg 11/17/2009 07:39'!
repeatAssert: aBlock equals: aResult

	self assert: (self wait: 0.5 until: aBlock evaluatesTo: aResult)! !

!GLMMorphicTest methodsFor: 'private' stamp: 'tg 12/29/2009 00:42'!
send: treeMorph doubleClickWithShift: aBoolean onItem: treeNodeMorph
	| event |
	event:= MouseButtonEvent basicNew 
		setType: #mouseDown
		position: (treeNodeMorph bounds origin + (1@1))
		which: 4
		buttons: (aBoolean ifTrue: [8] ifFalse: [0])
		hand: (HandMorph new mouseFocus: treeNodeMorph; yourself)
		stamp: nil.
	treeMorph doubleClick: event! !

!GLMMorphicTest methodsFor: 'private' stamp: 'tg 12/29/2009 00:39'!
send: treeMorph mouseDownWithShift: aBoolean onItem: treeNodeMorph
	| mouseUp |
	mouseUp := MouseButtonEvent basicNew 
		setType: #mouseDown
		position: (treeNodeMorph bounds origin + (1@1))
		which: 4
		buttons: (aBoolean ifTrue: [8] ifFalse: [0])
		hand: (HandMorph new mouseFocus: treeNodeMorph; yourself)
		stamp: nil.
	treeMorph mouseUp: mouseUp onMorph: treeNodeMorph.! !

!GLMMorphicTest methodsFor: 'private' stamp: 'tg 11/19/2009 11:39'!
send: treeMorph mouseUpOnItem: treeNodeMorph
	^ self send: treeMorph mouseUpWithShift: false onItem: treeNodeMorph! !

!GLMMorphicTest methodsFor: 'private' stamp: 'tg 11/29/2009 02:38'!
send: treeMorph mouseUpWithShift: aBoolean onItem: treeNodeMorph
	| mouseUp |
	mouseUp := MouseButtonEvent basicNew 
		setType: #mouseUp
		position: (treeNodeMorph bounds origin + (1@1))
		which: 4
		buttons: (aBoolean ifTrue: [8] ifFalse: [0])
		hand: (HandMorph new mouseFocus: treeNodeMorph; yourself)
		stamp: nil.
	treeMorph mouseUp: mouseUp onMorph: treeNodeMorph.! !

!GLMMorphicTest methodsFor: 'setup - tear down' stamp: 'tg 1/9/2010 22:12'!
tearDown
	window ifNotNil: [window delete]! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'lr 6/4/2010 13:53'!
testAllowNil
	| browser detailsMorph |
	browser := GLMTabulator new.
	browser 
		column: [: c | c row: #one; row: #two];
		column: #details.
	browser showOn: #one; using: [
		browser tree display: #(1 2 3)].
	browser showOn: #two; using: [
		browser tree display: #(a b c)].
	browser showOn: #details; from: #one; from: #two; using: [
		browser text 
			display: [ :one :two | one asString, two asString];
			allowNil ].
	window := browser openOn: 42.
	((browser paneNamed: #one) port: #selection) value: 2.
	detailsMorph := window submorphs last submorphs last submorphs first.
	self assert: detailsMorph getText = '2nil'.
	((browser paneNamed: #two) port: #selection) value: #c.
	detailsMorph := window submorphs last submorphs last submorphs first.
	self assert: detailsMorph getText = '2c'.
	((browser paneNamed: #one) port: #selection) value: nil.
	detailsMorph := window submorphs last submorphs last submorphs first.
	self assert: detailsMorph getText = 'nilc'.
! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'lr 6/4/2010 13:53'!
testChildrenBlock

	| browser check treeMorph treeNodeMorph |
	browser := GLMFinder new.
	check := false.
	browser tree
		children: [:each | check := true. #()].
	window := browser openOn: ($a to: $d).
	World doOneCycle.
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	self assert: treeMorph class = LazyMorphTreeMorph.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self repeatAssert: [check] equals: true
	! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 2/28/2010 21:50'!
testChildrenBlockTakesEntity

	| browser receivedEntity |
	browser := GLMFinder new.
	receivedEntity := nil.
	browser tree
		children: [:each :entity | receivedEntity := entity. #()].
	window := browser openOn: ($a to: $d).
	World doOneCycle.
	self repeatAssert: [receivedEntity] equals: ($a to: $d).
! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 2/28/2010 21:50'!
testColumnBlockTakesEntity

	| browser receivedEntity |
	browser := GLMFinder new.
	receivedEntity := nil.
	browser table
		column: 'Even' evaluated: [:each :entity | receivedEntity := entity. 'x'].
	window := browser openOn: (1 to: 5).
	World doOneCycle.
	self repeatAssert: [receivedEntity] equals: (1 to: 5).
! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 5/23/2010 22:11'!
testInterdependentPanesShouldUpdateTheFocusTriggerPane
	|browser treeMorphThree treeMorphThree2 |
	browser := GLMTabulator new.
	browser column: #one; column: #two; column: #three"; column: #four".
	browser transmit to: #one; andShow: [:a | a list display: [:x | 1 to: x]].
	browser transmit to: #two; from: #one; andShow: [:a | a list display: [:x | 1 to: x*2]].
	browser transmit to: #three; from: #two; andShow: [ :a |
		a list 
			display: [:x | 1 to: x*3];
			populate: #focus on: $f entitled: 'Focus' with: [:list | list selection] ].
"	browser showOn: #four; from: #three; using: [browser text allowNil]."
	browser transmit to: #outer->#focus; from: #three->#focus.
	browser transmit to: #one->#selection; from: #outer->#focus; transformed: [:x | x + 1].
	browser transmit to: #two->#selection; from: #outer->#focus; transformed: [:x | x + 2].
	window := browser openOn: 5.
	((browser paneNamed: #one) port: #selection) value: 3.
	((browser paneNamed: #two) port: #selection) value: 6.

	treeMorphThree := (window submorphs last submorphs at: 5) submorphs first submorphs first.

	((browser paneNamed: #three) port: #selection) value: 2.
	((browser paneNamed: #three) port: #focus) value: 1.

	self assert: ((browser paneNamed: #one) port: #entity) value = 5.
	self assert: ((browser paneNamed: #one) port: #selection) value = 2.
	self assert: ((browser paneNamed: #two) port: #entity) value = 2.
	self assert: ((browser paneNamed: #two) port: #selection) value = 3.
	self assert: ((browser paneNamed: #three) port: #entity) value = 3.
	self assert: ((browser paneNamed: #three) port: #selection) value isNil.

	treeMorphThree2 := (window submorphs last submorphs at: 5) submorphs first submorphs first.
	self assert: treeMorphThree ~= treeMorphThree2! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 4/6/2010 14:11'!
testInterdependentPanesShouldUpdateTheFocusTriggerPaneWithText
	|browser treeMorphThree treeMorphThree2 |
	browser := GLMTabulator new.
	browser column: #one; column: #two; column: #three"; column: #four".
	browser transmit to: #one; andShow: [:a | a text display: [:x | 1 to: x]].
	browser transmit to: #two; from: #one; andShow: [:a | a text display: [:x | 1 to: x*2]].
	browser transmit to: #three; from: #two; andShow: [ :a |
		a text 
			display: [:x | 1 to: x*3];
			populate: #focus on: $f entitled: 'Focus' with: [:list | list selection] ].
"	browser showOn: #four; from: #three; using: [browser text allowNil]."
	browser transmit to: #outer->#focus; from: #three->#focus.
	browser transmit to: #one->#selection; from: #outer->#focus; transformed: [:x | x + 1].
	browser transmit to: #two->#selection; from: #outer->#focus; transformed: [:x | x + 2].
	window := browser openOn: 5.
	((browser paneNamed: #one) port: #selection) value: 3.
	((browser paneNamed: #two) port: #selection) value: 6.

	treeMorphThree := (window submorphs last submorphs at: 5) submorphs first submorphs first.

	((browser paneNamed: #three) port: #selection) value: 2.
	((browser paneNamed: #three) port: #focus) value: 1.

	self assert: ((browser paneNamed: #one) port: #entity) value = 5.
	self assert: ((browser paneNamed: #one) port: #selection) value = 2.
	self assert: ((browser paneNamed: #two) port: #entity) value = 2.
	self assert: ((browser paneNamed: #two) port: #selection) value = 3.
	self assert: ((browser paneNamed: #three) port: #entity) value = 3.
	self assert: ((browser paneNamed: #three) port: #selection) value isNil.

	treeMorphThree2 := (window submorphs last submorphs at: 5) submorphs first submorphs first.
	self assert: treeMorphThree ~= treeMorphThree2! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'lr 6/4/2010 13:53'!
testListDoubleClick

	| browser treeMorph treeNodeMorph |
	browser := GLMFinder new.
	browser tree.
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	self send: treeMorph mouseUpWithShift: false onItem: treeNodeMorph.
	self send: treeMorph doubleClickWithShift: false onItem: treeNodeMorph.
	self assert: (browser panes first port: #strongSelection) value = $a.! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:13'!
testListDoubleClickWithMultipleSelection

	| browser treeMorph treeNodeMorph lastTreeNodeMorph |
	browser := GLMFinder new.
	browser tree beMultiple.
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	lastTreeNodeMorph := treeMorph scroller submorphs last.
	self send: treeMorph mouseUpWithShift: false onItem: treeNodeMorph.
	self send: treeMorph mouseUpWithShift: true onItem: lastTreeNodeMorph.
	self send: treeMorph doubleClickWithShift: false onItem: treeNodeMorph.
	self assert: (browser panes first port: #strongSelection) value asSet = ($a to: $d) asSet.! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 2/17/2010 23:11'!
testMultipleInitialSelection
	| browser firstTreeMorph secondTreeMorph |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser showOn: #one; using: [
		browser tree
			beMultiple;
			display: [:x | 1 to: x * 3]].
	browser showOn: #two; from: #one; using: [
		browser list ].
	window := browser openOn: 5.
	(browser panes first port: #selection) value: #(2 5 3).
	firstTreeMorph := window submorphs last submorphs second submorphs first submorphs first.
	secondTreeMorph := window submorphs last submorphs last submorphs first submorphs first.
	self assert: firstTreeMorph model selection notNil.
	self assert: firstTreeMorph model selection selectedItemOrItemsOrNil size = 3.
	self assert: secondTreeMorph model selection isNil.
	self assert: (secondTreeMorph model roots collect: #item) asSet = firstTreeMorph model selection selectedItemOrItemsOrNil asSet! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 2/17/2010 13:57'!
testMultiplePresentationsValidation
	| browser |
	browser := GLMFinder new.
	browser list.
	browser text.
	window := browser openOn: ($a to: $d).
	(browser panes first port: #selection) value: $z.
	self assert: (browser panes first port: #selection) value = $z! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'lr 6/4/2010 13:53'!
testNoSelection
	| browser treeMorph treeNodeMorph  |
	browser := GLMFinder new.
	browser tree noSelection.
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self assert: browser panes size = 1! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'lr 6/4/2010 13:53'!
testSpawnFinder
	| browser |
	browser := GLMFinder new.
	window := browser openOn: ($a to: $d).
	self repeatAssert: [window submorphs last class] equals: GLMPaneScroller.
! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'lr 6/4/2010 13:53'!
testSpawnTabulator

	| browser |
	browser := GLMTabulator new.
	window := browser openOn: ($a to: $d).
	self assert: window model == browser.
	self repeatAssert: [
		window submorphs last 
					submorphs last 
						submorphs last 
							submorphs last class] equals: LazyMorphTreeMorph.
! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 3/31/2010 22:52'!
testStatusbar
	| browser statusMorph |
	browser := GLMTabulator new.
	browser addStatusbar.
	browser row: #one.
	browser transmit to: #one; andShow: [:a | a list display: #(1 2 3)].
	window := browser openOn: 42.
	((browser paneNamed: #one) port: #status) value: 2.
	World doOneCycle.
	statusMorph := (window submorphs last: 2) first submorphs first.	
	self assert: (statusMorph isKindOf: LabelMorph).

"	detailsMorph := window submorphs last submorphs last submorphs first.
"! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'lr 6/4/2010 13:53'!
testTreeAllowDeseletion
	| browser treeMorph treeNodeMorph |	
	browser := GLMFinder new.
	browser list allowDeselection.
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self assert: (browser panes first port: #selection) value isNil! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'lr 6/4/2010 14:36'!
testTreeDefaultAllowDeseletion
	| browser treeMorph treeNodeMorph |
	browser := GLMFinder new.
	browser tree.
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self assert: (browser panes first port: #selection) value = $a.! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:14'!
testTreeMultipleSelection
	| browser treeMorph treeNodeMorph lastTreeNodeMorph |
	browser := GLMFinder new.
	browser tree beMultiple.
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	lastTreeNodeMorph := treeMorph scroller submorphs last.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self send: treeMorph mouseUpWithShift: true onItem: lastTreeNodeMorph.
	self assert: (browser panes first port: #selection) value notNil.
	self assert: (browser panes first port: #selection) value asSet = ($a to: $d) asSet! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:14'!
testTreeMultipleSelectionWithCancellation

	| browser treeMorph treeNodeMorph lastTreeNodeMorph |
	browser := GLMFinder new.
	browser tree beMultiple allowDeselection.
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	lastTreeNodeMorph := treeMorph scroller submorphs last.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self send: treeMorph mouseUpWithShift: true onItem: lastTreeNodeMorph.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self assert: (browser panes first port: #selection) value isNil! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:14'!
testTreeSelection

	| browser treeMorph treeNodeMorph |
	browser := GLMFinder new.
	browser tree.
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	self assert: treeMorph class = LazyMorphTreeMorph.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self assert: (browser panes first port: #selection) value = $a! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:14'!
testTreeSelectionCancellation

	| browser treeMorph treeNodeMorph |
	browser := GLMFinder new.
	browser tree allowDeselection.
	window := browser openOn: ($a to: $d).
	treeMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	treeNodeMorph := treeMorph scroller submorphs first.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self send: treeMorph mouseUpOnItem: treeNodeMorph.
	self assert: (browser panes first port: #selection) value isNil! !

!GLMMorphicTest methodsFor: 'testing' stamp: 'tg 1/9/2010 22:14'!
testTreeWithDisplay
	| browser treeCollection |
	treeCollection := { #root1->{#child1->{} . #child2->{}} . #root2 ->{} }.
	browser := GLMTabulator new.
	browser column: #one.
	browser showOn: #one; using: [
		browser tree
			display: [:each | each value ];
			children: [:x | x value ] ].
	window := browser openOn: #something -> treeCollection.
	self assert: browser panes first presentations first displayValue == treeCollection! !

!GLMMorphicTest methodsFor: 'private' stamp: 'tg 1/6/2010 00:36'!
wait: maxWaitSeconds until: validateBlock evaluatesTo: expectedResult
	"Evaluate validateBlock until it returns expectedResult or 
maxWaitSeconds have passed,
	 pausing between evaluations.  Return the last result of validateBlock 
value"

	| startTime result |
	startTime := Time millisecondClockValue // 1000.
	[result := validateBlock value = expectedResult] whileFalse:
			[Time secondClock - startTime > maxWaitSeconds ifTrue: [^result].
			(Delay forMilliseconds: 50) wait].
	^ result
! !

GLMMorphicTest subclass: #GLMTableMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMTableMorphicTest methodsFor: 'as yet unclassified' stamp: 'tg 4/20/2010 16:34'!
testColumnLabel
	| browser  tableMorphOne tableMorphTwo |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser transmit to: #one; andShow: [:a | 
		a table 
			display: [:x | (x - 3 to: x) ];
			column: 'Column' evaluated: [:x | x asString]].
	browser transmit to: #two; from: #one; andShow: [:a |
		a table 
			display: [:x | x * 10 to: (x * 10 + 2)];
			column: [:x | 'Number ', x asString] evaluated: #asString].
	window := browser openOn: 4.

	tableMorphOne := window submorphs last submorphs second submorphs first submorphs first.
	self assert: (tableMorphOne model roots collect: #item) = #(1 2 3 4).
	self assert: (tableMorphOne columns first header label = 'Column' ).
	((browser paneNamed: #one) port: #selection) value: 2.
	tableMorphTwo := window submorphs last submorphs last submorphs first submorphs first.
	self assert: (tableMorphTwo model roots collect: #item) = #(20 21 22).
	self assert: (tableMorphTwo columns first header label = 'Number 2' ).! !

GLMMorphicTest subclass: #GLMTextMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMTextMorphicTest methodsFor: 'testing' stamp: 'tg 1/26/2010 11:45'!
testMultipleSelectionWithChange
	| browser textMorph textPresentation |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [ :a | a text display: '123456789'].
	window := browser openOn: 4.

	textMorph := window submorphs last submorphs first submorphs first submorphs first submorphs first.
	self assert: textMorph selection isEmpty.
	textPresentation := (browser paneNamed: #one) presentations first.
	textPresentation selectionInterval: (2 to: 5).
	self assert: textMorph selection asString = '2345'! !

GLMMorphicTest subclass: #GLMTreeMorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMTreeMorphicTest methodsFor: 'testing' stamp: 'tg 1/26/2010 11:38'!
testMultipleSelectionWithChange
	| browser firstTreeMorph secondTreeMorph treeNodeMorph lastTreeNodeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [:a | a list beMultiple; display: [:x | (x - 2 to: x) ]].
	window := browser openOn: 4.

	firstTreeMorph := window submorphs last submorphs first submorphs first submorphs first.
	treeNodeMorph := firstTreeMorph scroller submorphs first.
	lastTreeNodeMorph := firstTreeMorph scroller submorphs last.
	self send: firstTreeMorph mouseUpOnItem: treeNodeMorph.
	self send: firstTreeMorph mouseUpWithShift: true onItem: lastTreeNodeMorph.
	self assert: (firstTreeMorph model selection selectedNodePathList collect: [:each | each first item]) =  #(2 3 4) asOrderedCollection.
	
	(browser pane port: #entity) value: 42.
	secondTreeMorph := window submorphs last submorphs first submorphs first submorphs first.
	treeNodeMorph := secondTreeMorph scroller submorphs first.
	lastTreeNodeMorph := secondTreeMorph scroller submorphs second.
	self send: secondTreeMorph mouseUpOnItem: treeNodeMorph.
	self send: secondTreeMorph mouseUpWithShift: true onItem: lastTreeNodeMorph.
	self assert: (secondTreeMorph model selection selectedNodePathList collect: [:each | each first item]) =  #(40 41) asOrderedCollection.! !

!GLMTreeMorphicTest methodsFor: 'testing' stamp: 'tg 1/14/2010 23:00'!
testMultipleSelectionWithChangeFromModel
	| browser firstTreeMorph secondTreeMorph |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit to: #one; andShow: [:a | a list beMultiple; display: [:x | (x - 2 to: x) ]].
	window := browser openOn: 4.

	firstTreeMorph := window submorphs last submorphs first submorphs first submorphs first.
	self assert: (firstTreeMorph model roots collect: #item) = #(2 3 4).
	((browser paneNamed: #one) port: #selection) value: #(2 3).
	self assert: ((browser paneNamed: #one) port: #selection) value asOrderedCollection = #(2 3) asOrderedCollection.
	
	(browser pane port: #entity) value: 42.
	secondTreeMorph := window submorphs last submorphs first submorphs first submorphs first.
	self assert: (secondTreeMorph model roots collect: #item) = #(40 41 42).
	((browser paneNamed: #one) port: #selection) value: #(40 41).
	self assert: ((browser paneNamed: #one) port: #selection) value asOrderedCollection = #(40 41) asOrderedCollection.

	self assert: firstTreeMorph ~= secondTreeMorph! !

!GLMTreeMorphicTest methodsFor: 'testing' stamp: 'tg 1/14/2010 23:00'!
testTwoPanesMultipleSelectionWithChange
	| browser treeMorphOne treeNodeMorph treeMorphTwo |
	browser := GLMTabulator new.
	browser column: #one; column: #two; column: #three.
	browser transmit to: #one; andShow: [:a |
		a list display: [:x | 1 to: x ]].
	browser transmit to: #two; from: #one; andShow: [:a |
		a list beMultiple; display: [:x | (x * 10) to: (x * 10 + 4) ] ].
	browser transmit to: #three; from: #two; andShow: [:a | a text ].
	window := browser openOn: 4.

	"we select 2 in the first pane"
	treeMorphOne := (window submorphs last submorphs at: 3) submorphs first submorphs first.
	treeNodeMorph := treeMorphOne scroller submorphs second.
	self send: treeMorphOne mouseUpOnItem: treeNodeMorph.

	"we select all in the second pane"
	treeMorphTwo := (window submorphs last submorphs at: 4) submorphs first submorphs first.
	treeNodeMorph := treeMorphTwo scroller submorphs first.
	self send: treeMorphTwo mouseUpOnItem: treeNodeMorph.
	treeNodeMorph := treeMorphTwo scroller submorphs second.
	self send: treeMorphTwo mouseUpWithShift: true onItem: treeNodeMorph.

	self assert: ((browser paneNamed: #two) port: #selection) value = #(20 21) asOrderedCollection.
	
	"we select 4 in the first pane"
	treeMorphOne := (window submorphs last submorphs at: 3) submorphs first submorphs first.
	treeNodeMorph := treeMorphOne scroller submorphs last.
	self send: treeMorphOne mouseUpOnItem: treeNodeMorph.

	"we select the first two in the second pane"
	treeMorphTwo := (window submorphs last submorphs at: 4) submorphs first submorphs first.
	self assert: (treeMorphTwo model roots collect: #item) = #(40 41 42 43 44).
	treeNodeMorph := treeMorphTwo scroller submorphs first.
	self send: treeMorphTwo mouseUpOnItem: treeNodeMorph.
	treeNodeMorph := treeMorphTwo scroller submorphs second.
	self send: treeMorphTwo mouseUpWithShift: true onItem: treeNodeMorph.

	self assert: ((browser paneNamed: #two) port: #selection) value = #(40 41) asOrderedCollection ! !

!GLMTreeMorphicTest methodsFor: 'testing' stamp: 'tg 6/5/2010 00:24'!
testUpdateFromModel
	| browser  treeMorphOne1 treeMorphTwo1 treeMorphOne2 treeMorphTwo2 |
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser transmit to: #one; andShow: [:a | a list display: [:x | (x - 3 to: x) ]].
	browser transmit to: #two; from: #one; andShow: [:a |
		a list display: [:x | x * 10 to: (x * 10 + 2)]].
	window := browser openOn: 4.

	treeMorphOne1 := window submorphs last submorphs second submorphs first submorphs first.
	self assert: (treeMorphOne1 model roots collect: #item) = #(1 2 3 4).
	((browser paneNamed: #one) port: #selection) value: 2.	
	treeMorphTwo1 := window submorphs last submorphs last submorphs first submorphs first.
	self assert: (treeMorphTwo1 model roots collect: #item) = #(20 21 22).

	browser entity: 8.

	treeMorphOne2 := window submorphs last submorphs second submorphs first submorphs first.
	self assert: (treeMorphOne2 model roots collect: #item) = #(5 6 7 8).
	self assert: treeMorphOne1 ~= treeMorphOne2.

	self assert: (window submorphs last submorphs last submorphs first submorphs) isEmpty.
	
	((browser paneNamed: #one) port: #selection) value: 5.	
	treeMorphTwo2 := window submorphs last submorphs last submorphs first submorphs first.
	self assert: (treeMorphTwo2 model roots collect: #item) = #(50 51 52).
	self assert: treeMorphTwo1 ~= treeMorphTwo2! !

GLMMorphicTest subclass: #GLMUpdateMorphicTest
	instanceVariableNames: 'announcer entity browser treeMorph listMorph tableMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Tests-Morphic'!

!GLMUpdateMorphicTest methodsFor: 'testing' stamp: 'tg 8/24/2010 22:02'!
setUp
	announcer := Announcer new.
	entity := OrderedCollection with: 1 with: 2 with: 3.
	browser := GLMTabulator new.
	browser column: #one; column: #two.
	browser transmit to: #one; andShow: [ :a |
		a verticallyStackedArrangement.
		a list 
			updateOn: TestAnnouncement from: [ announcer ];
			shouldValidate: true.
		a tree 
			children: #();
			updateOn: TestAnnouncement from: [ announcer ];
			shouldValidate: true.
		a table
			updateOn: TestAnnouncement from: [ announcer ];
			shouldValidate: true ].
	browser showOn: #two; from: #one; using: [browser text].
	window := browser openOn: entity.
	listMorph := window submorphs last submorphs second submorphs first submorphs first submorphs first submorphs first submorphs first.
	treeMorph := window submorphs last submorphs second submorphs first submorphs second submorphs first submorphs first submorphs first.
	tableMorph := window submorphs last submorphs second submorphs first submorphs last submorphs first submorphs first submorphs first.! !

!GLMUpdateMorphicTest methodsFor: 'testing' stamp: 'tg 2/22/2010 13:35'!
testAdd
	entity add: 4.
	announcer announce: TestAnnouncement.
	self assert: listMorph model roots size = 4.
	self assert: treeMorph model roots size = 4.
	self assert: tableMorph model roots size = 4.
! !

!GLMUpdateMorphicTest methodsFor: 'testing' stamp: 'tg 4/15/2010 17:16'!
testAnnouncerUnregistration
	| subscription |
	subscription := announcer instVarNamed: 'subscriptions'.
	self assert: (subscription at: TestAnnouncement) size = 3.
	browser entity: #($a $b).
	subscription := announcer instVarNamed: 'subscriptions'.
	self assert: (subscription at: TestAnnouncement) size = 3.
	browser entity: #($d).
	subscription := announcer instVarNamed: 'subscriptions'.
	self assert: (subscription at: TestAnnouncement) size = 3.
	browser entity: #().
	subscription := announcer instVarNamed: 'subscriptions'.
	self assert: (subscription at: TestAnnouncement) size = 3.
	browser unregisterFromAllAnnouncements.
	subscription := announcer instVarNamed: 'subscriptions'.
	self deny: (subscription includesKey: TestAnnouncement)! !

!GLMUpdateMorphicTest methodsFor: 'testing' stamp: 'tg 2/28/2010 21:32'!
testInvalidateSelection
	(browser panes first port: #selection) value: 3.
	entity removeLast.
	announcer announce: TestAnnouncement.
	self assert: (browser panes first port: #selection) value isNil.
	self assert: listMorph model selection isNil! !

!GLMUpdateMorphicTest methodsFor: 'testing' stamp: 'tg 2/22/2010 13:39'!
testRemove
	entity removeLast.
	announcer announce: TestAnnouncement.
	self assert: listMorph model roots size = 2.
	self assert: treeMorph model roots size = 2.
	self assert: tableMorph model roots size = 2.! !

!GLMUpdateMorphicTest methodsFor: 'testing' stamp: 'tg 8/24/2010 22:06'!
testUpdateBrowserTitle

	browser title: 'something'.
	browser update.
	self assert: window label = 'something'! !
